#include "stdafx.h"

#include <malloc.h>
#include <string.h>
#include "seznam.h"

bool listAdd(listDescr *list, char *txt)
{
	item *temp;
	for (temp = list->first; temp; temp = temp->next)
	{
		if (strcmp(txt, temp->word) == 0)
		{
			temp->count++;
			return true;
		}
	}
	temp = (item *)malloc(sizeof(item));
	if (temp == NULL)
	{
		return false;
	}
	temp->word = (char *)malloc((strlen(txt) + 1)*sizeof(char));
	if (temp->word == NULL)
	{
		free(temp);
		return false;
	}
	strcpy(temp->word, txt);
	temp->count = 1;
	temp->next = list->first;
	list->first = temp;
}

void listShow(listDescr *list)
{
	item *temp;
	int poc = 1;
	if (list->first == NULL)
	{
		printf("Seznam je prazdny.\n");
		return;
	}
	printf("Zacatek seznamu: %p\n", list->first);
	for (temp = list->first; temp; temp = temp->next)
	{
		printf("%3d Adresa: %p Cetnost: %3d Slovo: %s  Dalsi: %p\n", poc, temp,
			temp->count, temp->word, temp->next);
		poc++;
	}
}

bool listClear(listDescr *list)
{
	item *temp;
	if (list->first == NULL) return false;
	while (list->first)
	{
		temp = list->first;
		list->first = temp->next;
		free(temp->word);
		free(temp);
	}
	return true;
}

